#!/usr/bin/perl
use strict;
use Data::Dumper;

my $homes = [];
my @ibg = ();
my $size = 1000;
for (my $i = 0; $i < $size; $i++) {
  my $row = '';
  for (my $j = 0; $j < $size; $j++) {
    my $square = "\.";
    if (int(rand(1000)) > 998) {
      $square = '@';
      push @$homes, [$i,$j]
    } elsif (int(rand(10)) > 8) {
      $square = '#';
    }
    $row .= $square;
  }
  push(@ibg, $row);
}
foreach my $guy (@ibg) {
  print "$guy\n";
}

foreach my $home (@$homes) {
  print "HOME : " . Dumper($home);
}
